
--- Rydd opp i variabler til slutt:
num = 0
center = { X = 0, Y = 0}
gGravityF = 0
gPCEq = 557
gHammerTime = 0
gLvlProgress = 0
gCurrentLevel = 0
gCurrentCompletedLevel = -1
gLastLevel = 5
min_dt = 0
next_time = 0
goalzone = {0,0,0,0}

gGameState = "Menu"
gSound = true
gScore = 0
-- Bare endre verdien p menu.bgmusic nr vi bytter bane. trenger bare en vel?
local t = 0
gAllowNextLevel = 0
progTime = 0 -- tid brukt. 

function love.load()

	local menu = require("lua/menu")
	local keyboard = require("lua/keyboard")
	
	
	
 
	fontscalable = {	default = love.graphics.newFont(24),
				large = love.graphics.newFont(32),
				huge = love.graphics.newFont(72),
				small = love.graphics.newFont(22) }
	love.graphics.setFont(fontscalable.default);
	
    min_dt = 1/60
    next_time = love.timer.getMicroTime()
 
	love.graphics.setMode(1024, 768, false, true, 0) --set the window dimensions to 650 by 650 with no fullscreen, vsync on, and no antialiasing
	--love.graphics.setBackgroundColor(0,0,0)
	bg = love.graphics.newImage("gfx/menubg.png")
	menubg = love.graphics.newImage("gfx/menubg.png")
	bar = love.graphics.newImage("gfx/bar.png")
		
	center.X = love.graphics.getWidth() / 2
	center.Y = love.graphics.getHeight() / 2
   
	love.physics.setMeter(768) --the height of a meter our worlds will be 64px
	world = love.physics.newWorld(0, 0, true)  --Create World

	objects = {} -- table to hold all our physical objects
	
	infotext = ""
	car1GFX = love.graphics.newImage("gfx/car1.png")
	car2GFX = love.graphics.newImage("gfx/car2.png")
	car3GFX = love.graphics.newImage("gfx/car1.png")
	car4GFX = love.graphics.newImage("gfx/car2.png")
	crateGFX = love.graphics.newImage("gfx/crate70x90.png")
	wallGFX = love.graphics.newImage("gfx/wall20x200.png") 
	
	createGround()
	createWalls()
	createCar()
	 
	LoadLevel(0) -- Start with the menu!

	
	-- Start Musikk:
	bgmusic = love.audio.newSource("sound/Kevin MacLeod - Decisions.mp3", "stream")
	bgmusic:setLooping(true)
	love.audio.setVolume(0.7)
	love.audio.play(bgmusic)
	
	sndEngine = love.audio.newSource("sound/eng.wav", "static") -- the "static" tells LVE to load the file into memory, good for short sound effects
	
	-- Pixel effects:
	effect = love.graphics.newPixelEffect [[
        extern number time;
        vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
        {
            return vec4((1.0+sin(time))/2.0, abs(cos(time)), abs(sin(time)), 0.1);
        }
    ]]
	
end


function love.draw()
		
   if gGameState == "Menu" then
		drawMenu()
		love.graphics.draw(bg, 0, 0)
	elseif gGameState == "Credits" then
		drawCredits()
	elseif gGameState == "Dead" then
		drawScore()
	elseif gGameState == "Play" then
	
		
		love.graphics.setCaption("Ludicrous Parking LD27 - (fps:" .. love.timer.getFPS() ..")")
		
		-- Draw background
		love.graphics.setColor(255,255,255)
		love.graphics.draw(bg, 0, 0)
		
		love.graphics.draw(bar, 1, 1,0 , 1, 0.5, 0, 0)
		 
		-- Draw progress bar
		drawBars((center.X - 141),13,{235,235,0},gLvlProgress)
			
		love.graphics.setColor(255, 204, 102) 
		love.graphics.polygon("fill", objects.ground.body:getWorldPoints(objects.ground.shape:getPoints())) -- draw a "filled in" polygon using the ground's coordinates
		 
		
		love.graphics.setColor(255, 255, 255,0) 
		love.graphics.polygon("fill", objects.car.body:getWorldPoints(objects.car.shape:getPoints()))
		love.graphics.setColor(200,255,255)
		
		
		love.graphics.setColor(100, 0, 0,100) 
		love.graphics.setPixelEffect(effect)
		love.graphics.rectangle("fill", goalzone.startx, goalzone.starty, goalzone.widthx, goalzone.widthy )
		love.graphics.setPixelEffect()
		love.graphics.rectangle("line", goalzone.startx, goalzone.starty, goalzone.widthx, goalzone.widthy )
		love.graphics.setColor(255, 255,255) 
		
		DrawCurrentLevel()
		DrawCar()
		
		-- Print tekst
		love.graphics.setFont(fontscalable.large);
		love.graphics.setColor(0, 0, 0) 
		love.graphics.printf(infotext ,12, 252,1014,"center")
		love.graphics.setColor(255, 255,255) 
		love.graphics.printf(infotext ,10, 250,1014,"center")
		
		love.graphics.setFont(fontscalable.default);
		
		love.graphics.printf(gCurrentLevel+1 ,170,12,60,"right")
		love.graphics.printf(gScore ,800, 12,100,"right")
		
		
		
	end
		
	--FPS code need s to be last thing that is calculated in draw()
	local cur_time = love.timer.getMicroTime()
	if next_time <= cur_time then
		next_time = cur_time
		return
	end
	

	love.timer.sleep(next_time - cur_time)
end

function LoadLevel(level)
	if gGameState == "Play" then
	 level = level+1 -- increase by 1
	 end -- ellers er det menyen (0)
	-- Require:r
	local layout = require("lua/level_" .. level)
	
end


function ClearCurrentLevel()
-- Remove all objects from this level.


end

function IsInGoal()
	cx, cy = objects.car.body:getPosition()
	--cx = cx - 72
	--cy = cy - 72 --Lenght offset
	
	--angle = objects.car.body:getAngle( )
	--gDt = angle+math.rad(90)
	
	--[[
	if cx <= goalzone.startx and cy <= goalzone.starty  then
		infotext = "Made it grasts!!!!!"
	end	
	--]]		
	--.----get body xy
 	-- goalzone.startx, goalzone.starty, goalzone.widthx, goalzone.widthy
	gAllowNextLevel = 0
	if cx >= goalzone.startx and cx < (goalzone.startx + goalzone.widthx) and (cx + 30) <= (goalzone.startx + goalzone.widthx) then
		if cy >= goalzone.starty  and cy < (goalzone.starty + goalzone.widthy) and (cy + 30) <= (goalzone.starty + goalzone.widthy)  then
		--	THIS MEANS YOU WIN!
			gCurrentCompletedLevel = gCurrentLevel
			objects.car.body:setActive(false)
			infotext = "Yay you made it! Press N  for next level"
			gAllowNextLevel = 1
		else 
			infotext = ""
		end
	else
		infotext = ""
	end
		
end


function createWalls()
	-- Walls, de trengs uansett.
	objects.leftWall = {}
	objects.leftWall.body = love.physics.newBody(world, 0, love.graphics.getHeight()/2, "static")
	objects.leftWall.shape = love.physics.newRectangleShape(1, love.graphics.getHeight())
	objects.leftWall.fixture = love.physics.newFixture(objects.leftWall.body, objects.leftWall.shape, 1)
	
	objects.rightWall = {}
	objects.rightWall.body = love.physics.newBody(world, love.graphics.getWidth()+1, center.Y, "static")
	objects.rightWall.shape = love.physics.newRectangleShape(1, love.graphics.getHeight())
	objects.rightWall.fixture = love.physics.newFixture(objects.rightWall.body, objects.rightWall.shape, 0)
	
	objects.topWall = {}
	objects.topWall.body = love.physics.newBody(world, center.X, 0, "static")
	objects.topWall.shape = love.physics.newRectangleShape( love.graphics.getWidth(), 1)
	objects.topWall.fixture = love.physics.newFixture(objects.topWall.body, objects.topWall.shape, 0)
end

function createCar()
	--let's create a car
	carGfx = love.graphics.newImage("gfx/car1.png")
	
	objects.car = {}
	objects.car.body = love.physics.newBody(world, 160, 768/2, "dynamic") --place the body in the center of the world and make it dynamic, so it can move around
	objects.car.shape = love.physics.newRectangleShape(143,66)
	
	--objects.car.body:setMass(1)
	objects.car.body:setAngularDamping(22)
	objects.car.body:setLinearDamping(10)
	objects.car.fixture = love.physics.newFixture(objects.car.body, objects.car.shape, 1) -- Attach fixture to body and give it a density of 1.
	objects.car.fixture:setRestitution(0.1) --level bounce
end
function DrawCar()	
	carx, cary = objects.car.body:getPosition( )
	angle = objects.car.body:getAngle( )
	love.graphics.setColor(255, 255, 255) 
	love.graphics.draw(carGfx, carx, cary, angle+math.rad(90), 1, 1, 35, 72)
end

function createGround()
	--let's create the ground
	objects.ground = {}
	objects.ground.body = love.physics.newBody(world, center.X, (love.graphics.getHeight() - 1)) --remember, the shape (the rectangle we create next) anchors to the body from its center, so we have to move it to (650/2, 650-50/2)
	objects.ground.shape = love.physics.newRectangleShape(1024, 2) --make a rectangle with a width of 650 and a height of 50
	objects.ground.fixture = love.physics.newFixture(objects.ground.body, objects.ground.shape,0.5) --attach shape to body
end

function drawScore()
	local scoreText = {3,"Too hard? Your score is:" .. gScore, "Press R to restart current level."}
	
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(menubg, 0, 0)

    for i = 2, scoreText[1], 1 do
		label = scoreText[i]
		love.graphics.setNewFont(44)
		love.graphics.setColor(255,255,255, math.min(255,150))
		 love.graphics.printf(label, menu.x, menu.y + (i * 40), 700, "center")		
	end		
	love.graphics.setColor(255,255,255,255)
end

function drawBars(x,y,colour,percent)
	
	local bottomAnchor = true
	local barH = 25
	local barW = 262
	local trans = 500
	local linewidth = 1.5
	local yOffset = (y+3)
	local power = 3
	love.graphics.setLineWidth(linewidth, "smooth")

	love.graphics.setColor(0, 0, 0, 100)
	love.graphics.rectangle("fill", x, y, barW,barH ) -- shadow
	love.graphics.setColor(colour[1], colour[2],colour[3], trans)
 
	love.graphics.rectangle("fill", x+power,yOffset, (barW-(power*2))*(percent/100),(barH-(power*2)) )
end

function love.update(dt)
	next_time = next_time + min_dt
	
	world:update(dt) --this puts the world into motion

	-- Update progress
	-- Check if lvl is completed and stop time
	if gGameState == "Play" then
		progTime = love.timer.getTime( )
		if progTime - gHammerTime <= 10 then
			if gCurrentLevel ~= gCurrentCompletedLevel then
				gLvlProgress = (progTime - gHammerTime) * 10
			end
		else
			if gCurrentLevel ~= gCurrentCompletedLevel then
				gLvlProgress = 100
				gGameState = "Dead"
			end
		end
	end

	
	local forward_x = math.cos(objects.car.body:getAngle())
    local forward_y = math.sin(objects.car.body:getAngle())
	
	local reverse_x = math.cos(objects.car.body:getAngle()) *-1
	local reverse_y = math.sin(objects.car.body:getAngle()) *-1
	
	fspeed = 100
	fturn = 0.15
	turnForce = 12
	
	-- =======================================
	-- KEYBOARD EVENTS
	-- =======================================
	if gGameState ~= "Menu" then
		if love.keyboard.isDown("up") then -- Move car forward!
			objects.car.body:applyForce( fspeed * forward_x, fspeed * forward_y)
			if math.random(2) == 1 then
				love.audio.play(sndEngine)
			else
				love.audio.stop(sndEngine)
			end
			
		elseif love.keyboard.isDown("down") then 
			objects.car.body:applyForce(fspeed/2 * reverse_x, fspeed/2 * reverse_y)
			if math.random(2) == 1 then
				love.audio.play(sndEngine)
			else
				love.audio.stop(sndEngine)
			end
		end
		
		if love.keyboard.isDown("up") and love.keyboard.isDown("right") then --FORWARD RIGHT
			if (objects.car.body:getY()/768) < 0.3 then
				objects.car.body:applyForce( turnForce + (turnForce * (1- (objects.car.body:getY()/768))),0,0,0)
			else
				objects.car.body:applyForce( turnForce,0,0,0)
			end
		elseif love.keyboard.isDown("up")and love.keyboard.isDown("left") then --FORWARD LEFT
			if (objects.car.body:getY()/768) < 0.3 then
				objects.car.body:applyForce( -turnForce - (turnForce * (1- (objects.car.body:getY()/768))),0,0,0)
			else
				objects.car.body:applyForce( -turnForce,0,0,0)
			end
		end
		
		if love.keyboard.isDown("down") and love.keyboard.isDown("right") then --FORWARD RIGHT
			if (objects.car.body:getY()/768) < 0.3 then
				objects.car.body:applyForce( -turnForce - (turnForce * (1- (objects.car.body:getY()/768))),0,0,0)
			else
				objects.car.body:applyForce( -turnForce,0,0,0)
			end
		elseif love.keyboard.isDown("down")and love.keyboard.isDown("left") then --FORWARD LEFT
			if (objects.car.body:getY()/768) < 0.3 then
				objects.car.body:applyForce( turnForce + (turnForce * (1- (objects.car.body:getY()/768))),0,0,0)
			else
				objects.car.body:applyForce( turnForce,0,0,0)
			end
		end
	end	
	-- =======================================
	-- KEYBOARD EVENTS
	-- =======================================
	
	-- funksjonen koster mye.. cpu
	if math.random(10) == 1 then
	   IsInGoal()
	end
	
	 -- Effect update:
	 t = t + dt
    effect:send("time", t)
end
 


